//JLM0001  JOB (SYSGEN),'J02 M02: JLM0001',
//             CLASS=A,
//             MSGCLASS=A,
//             MSGLEVEL=(1,1),
//             REGION=4096K
/*JOBPARM LINES=100
//*
//*********************************************************************
//* Install USERMOD JLM0001 - IEFACTRT exit to provide job/step       *
//* accounting information (source: Jay Moseley-08/2020)              *
//*********************************************************************
//* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//UPDATE01 EXEC PGM=IEBUPDTE,PARM=NEW
//SYSPRINT DD  SYSOUT=*
//SYSUT2   DD  DISP=SHR,DSN=SYS1.UMODSRC
//SYSIN    DD  *
./ ADD NAME=IEFACTRT
*********************************************************************** 00000115
* LOCAL MACROS DEFINED BELOW:                                         * 00000215
*    FILL ----- INITIALIZE A DATA AREA WITH SINGLE CHARACTER. IF NO   * 00000315
*               CHARACTER SUPPLIED WITH CALL, DEFAULT IS SPACE.       * 00000415
*    STEPWTO -- WRITE A MESSAGE ON CONSOLE. IF NO FIELD SUPPLIED,     * 00000515
*               TEXT IS USED FROM AREA CONTAINING STEP COMPLETION     * 00000615
*               FIELDS. (MESSAGE LENGTH LIMITED TO SIZE DEFINED FOR   * 00000715
*               STEP COMPLETION FIELDS)                               * 00000815
*    WRSYSOUT - CALL IEFYS TO WRITE LINE BUFFER TO SYSTEM LOG.        * 00000915
*********************************************************************** 00001015
*                                                                       00001115
         MACRO                                                          00001201
&LABEL   FILL  &AREA,&CHAR                                              00001308
         LCLC  &CHAR$                                                   00001401
&CHAR$   SETC  'C'' '''                DEFAULT FILL CHARACTER           00001502
         AIF   ('&CHAR' EQ '').NOFILL  USE DEFAULT FILL CHAR            00001602
&CHAR$   SETC  '&CHAR'                 USER FILL CHARACTER              00001702
.NOFILL  ANOP                                                           00001802
&LABEL   MVI   &AREA,&CHAR$            SET FILL BYTE                    00001902
         MVC   &AREA+1(L'&AREA-1),&AREA  FILL FIELD                     00002002
         MEND                                                           00002102
*                                                                       00002233
         MACRO                                                          00002302
&NAME    STEPWTO &MSG                                                   00002402
         MVC   WTOBUF,WTODEF           MOVE LIST MACRO TO DYN. STORAGE  00002502
         AIF   (T'&MSG NE 'O').MSG                                      00002602
         MVC   WTOBUF+4(WTOMSGL),ACTRMSG COPY STANDARD MESSAGE TEXT     00002725
         AGO   .WTO                                                     00002802
.MSG     ANOP                                                           00002902
         MVC   WTOBUF+4(WTOMSGL),&MSG  INSERT PASSED MESSAGE TEXT       00003025
.WTO     ANOP                                                           00003102
         LA    R1,WTOBUF               POINT TO LIST MACRO              00003202
         WTO   MF=(E,(1))                AND ISSUE WTO SVC              00003302
         MEXIT                                                          00003402
         MEND                                                           00003502
*                                                                       00003633
         MACRO                                                          00003710
&NAME    WRSYSOUT ,                    CALL IEFYS TO WRITE SYSOUT       00003810
         MVC   36(4,R12),SYSOUT@       MOVE ADDR TO IEFYS COMM AREA     00003910
         MVC   42(2,R12),SYSOUT#       MOVE LENGTH TO IEFSY COMM AREA   00004010
         L     R15,=V(IEFYS)           LOAD IEFYS ENTRY ADDRESS         00004110
         BALR  R14,R15                 CALL IEFYS                       00004210
         MEND                                                           00004310
*                                                                       00004415
*********************************************************************** 00004515
* END OF LOCAL MACRO DEFINITIONS                                      * 00004615
*********************************************************************** 00004715
*                                                                       00004815
         WXTRN IEFYS                   ENTRY POINT OF SYSTEM LOG WRITE  00004915
*                                                                       00005015
         TITLE 'JOB/STEP PROCESSING EXIT'                               00005100
IEFACTRT CSECT                                                          00005200
*                                                                       00005300
*********************************************************************** 00005400
*                                                                     * 00005500
*                                                                     * 00005600
*    IIII   EEEEEE  FFFFFFF    A     CCCCC TTTTTTTT RRRRRR TTTTTTTT   * 00005700
*     II    EE      FF        AAA   CC   CC   TT    RR   RR   TT      * 00005800
*     II    EE      FF       AA AA  CC   CC   TT    RR   RR   TT      * 00005900
*     II    EEEE    FFFFF   AA   AA CC        TT    RR   RR   TT      * 00006000
*     II    EE      FF      AA   AA CC        TT    RRRRRR    TT      * 00006100
*     II    EE      FF      AAAAAAA CC   CC   TT    RR RR     TT      * 00006200
*     II    EE      FF      AA   AA CC   CC   TT    RR  RR    TT      * 00006300
*    IIII   EEEEEEE FF      AA   AA  CCCCC    TT    RR   RR   TT      * 00006400
*                                                                     * 00006500
*                                                                     * 00006600
*********************************************************************** 00006700
*                                                                     * 00006815
* FUNCTION                                                            * 00006915
*    THIS MODULE IS ENTERED AT JOB/STEP TERMINATION. IF THE           * 00007015
*    MODULE WAS ENTERED FOR STEP TERMINATION, INFORMATION IS          * 00007115
*    EXTRACTED AND WRITTEN TO THE SYSOUT DATASET USING THE IEFYS      * 00007215
*    ROUTINE, AND A MESSAGE IS WRITTEN TO THE CONSOLE INDICATING      * 00007315
*    THE STEP COMPLETION INFORMATION.                                 * 00007415
*                                                                     * 00007515
* ENTRY POINT - IEFACTRT                                              * 00007615
*                                                                     * 00007715
* INPUT                                                               * 00007815
*    REGISTER 0 INDICATES REASON FOR ENTRY:                           * 00007915
*      12 - STEP TERMINATION                                          * 00008015
*      16 - JOB TERMINATION                                           * 00008115
*                                                                     * 00008215
*    REGISTER 1 POINTS TO A LIST OF 4 BYTE ADDRESSES FOR THE          * 00008315
*    FOLLOWING TEN PARAMETERS:                                        * 00008415
*      1 - POINTER TO COMMON EXIT PARAMETER BLOCK (FIELDS MOVED TO    * 00008545
*          LOCAL WORK AREA).  FIELDS ARE: JOB NAME, DATE/TIME, SMF    * 00008645
*          SYSTEM ID, USERID, STEP NUMBER, SMF OPTION, RESTART        * 00008745
*          INDICATOR, JOB CLASS, USER COMMUNICATION AREA (4 BYTES).   * 00008845
*      2 - STEP NAME (ADDRESS IS ZERO FOR JOB TERM ENTRY)             * 00008915
*      3 - PROGRAMMERS NAME                                           * 00009015
*      4 - JOB EXECUTION TIME                                         * 00009115
*      5 - JOB ACCOUNTING FIELDS                                      * 00009215
*      6 - STEP EXECUTION TIME                                        * 00009315
*      7 - STEP ACCOUNTING FIELDS                                     * 00009415
*      8 - FLAGS AND STEP NUMBER                                      * 00009515
*      9 - TERMINATION STATUS                                         * 00009615
*     10 - SMF TERMINATION RECORD                                     * 00009715
*                                                                     * 00009815
* OUTPUT - NONE                                                       * 00009915
*                                                                     * 00010015
* EXIT - NORMAL = AT PROGRAM END VIA BRANCH REGISTER 14               * 00010115
*                                                                     * 00010215
* EXTERNAL REFERENCES                                                 * 00010315
*    IEFYS - WRITES LINE TO SYSTEM LOG                                * 00010415
*                                                                     * 00010515
* DSECTS                                                              * 00010615
*    IEFJMR - JOB MANAGEMENT                                          * 00010745
*    IFASMFR - SMF RECORD FORMAT (RECORD TYPE 4 USED)                 * 00010815
*    IHASDWA - SDWA FOR ESTAE/SETRP MACRO                             * 00010945
*    WORKAREA - INTERNAL FIELDS STORED IN MEMORY EXTERNAL TO PROGRAM  * 00011015
*                                                                     * 00011145
* ATTRIBUTES - KEY 0, REENTRANT                                       * 00011215
*                                                                     * 00011315
* CHARACTER CODE DEPENDENCY - NONE                                    * 00011415
*                                                                     * 00011515
* EXTERNAL MACROS USED: GETMAIN, FREEMAIN                             * 00011615
*                                                                     * 00011715
* REGISTER USAGE:                                                     * 00011845
*    R8 - USED FOR SUBROUTINE LINKAGE                                 * 00011945
*    R10 - SMF RECORD                                                 * 00012045
*    R11 - BASE REGISTER                                              * 00012145
*    R12 - RESERVED FOR IEFYS COMMUNICATION                           * 00012245
*    R13 - WORK AREA OBTAINED BY GETMAIN, INCLUDES MY SAVE AREA       * 00012345
*                                                                     * 00012445
* WRITTEN BY JAY MOSELEY IN JULY, 2020                                * 00012525
*                                                                     * 00012615
* MODIFICATIONS                                                       * 00012715
*                                                                     * 00012815
*   2002/08/29 JLM: ERROR IN COMPUTING LENGTH OF WTO MESSAGE AREA-    * 00012948
*                   AS ORIGINALLY CODED, MVC OF STEP END MESSAGE TO   * 00013048
*                   WTO MESSAGE AREA INCLUDED MCS FLAGS, WHICH COULD  * 00013148
*                   RANDOMLY AFFECT MESSAGE HIGHLIGHTING.             * 00013248
*                                                                     * 00013348
*********************************************************************** 00013400
         EJECT                                                          00013500
SUBPOOL  EQU   241                     SUBPOOL FOR WORK AREA            00013645
R0       EQU   0                       REGISTER 0                       00013700
R1       EQU   1                       REGISTER 1                       00013800
R2       EQU   2                       REGISTER 2                       00013900
R3       EQU   3                       REGISTER 3                       00014000
R4       EQU   4                       REGISTER 4                       00014100
R5       EQU   5                       REGISTER 5                       00014200
R6       EQU   6                       REGISTER 6                       00014300
R7       EQU   7                       REGISTER 7                       00014400
R8       EQU   8                       REGISTER 8                       00014500
R9       EQU   9                       REGISTER 9                       00014600
R10      EQU   10                      REGISTER 10                      00014700
R11      EQU   11                      REGISTER 11                      00014800
R12      EQU   12                      REGISTER 12                      00014900
R13      EQU   13                      REGISTER 13                      00015000
R14      EQU   14                      REGISTER 14                      00015100
R15      EQU   15                      REGISTER 15                      00015200
         USING IEFACTRT,R15            TEMPORARY ADDRESSABILITY         00015300
         B     BEGIN                   BRANCH AROUND IDENT FIELDS       00015400
IDENTITY DS    0H                      BEGIN IDENTIFICATION FIELDS      00015545
         DC    AL1(BEGIN-IDENTITY)     LENGTH OF IDENTIFICATION FIELDS  00015600
         DC    CL8'IEFACTRT'           CSECT NAME                       00015700
         DC    C'&SYSDATE. @ &SYSTIME' ASSEMBLY DATE AND TIME           00015802
BEGIN    DS    0H                      END OF IDENTIFICATION FIELDS     00015900
         STM   R14,R12,12(R13)         ENTRY LINKAGE                    00016001
         L     R7,0(,R1)               CEP LIST                         00016143
         USING JMR,R7                  SET UP ADDRESSABILITY            00016243
         TM    JMRINDC,JMRFIND         IS THIS TSO USER?                00016343
         BO    QUIKEXIT                  YES, EXIT NOW                  00016443
         DROP  R7                      DROP CEPLIST ADDRESSABILITY      00016543
         DROP  R15                     DROP TEMPORARY BASE              00016600
         BALR  R11,R0                  REGISTER 11 AS BASE REGISTER     00016700
         USING *,R11                   SET UP ADDRESSABILITY            00016800
         L     R0,WALNGTH              LOAD GETMAIN INFORMATION         00016945
         GETMAIN R,LV=(0)              ACQUIRE MEMORY FOR WORK AREA     00017015
         LR    R15,R13                 SAVE OLD SAVE AREA POINTER       00017101
         LR    R13,R1                  R13 POINTS TO NEW SAVE AREA      00017201
         USING WORKAREA,R13            SET UP ADDRESSABILITY TO WORK    00017304
         LM    R0,R1,20(R15)           RESTORE ORIGINAL R0/R1           00017409
         ST    R15,4(R13)              OLD SAVE AREA ADDRESS INTO NEW   00017501
         ST    R13,8(R15)              NEW SAVE AREA ADDRES INTO OLD    00017601
         LR    R3,R0                   ORIGINAL R0 TO R3                00017710
*                                                                       00017836
* SAVE ADDRESSES PASSED IN R1 LIST                                      00017936
*                                                                       00018036
         MVC   PLCEPADR(40),0(R1)      COPY 10 ADDRESSES TO WORK AREA   00018145
*                                                                       00018237
* SAVE COMMON EXIT PARAMETER LIST FIELDS                                00018337
*                                                                       00018437
         L     R1,PLCEPADR             GET ADDRESS OF CEP LIST          00018545
         MVC   CEPJOBN(36),0(R1)       COPY 11 FIELDS TO WORK AREA      00018645
*                                                                       00018733
* SET UP RECOVERY ENVIRONMENT                                           00018833
*                                                                       00018933
         MVC   ESTAEW(LESTAEL),ESTAEL  MOVE IN ESTAE PARAMETER LIST     00019033
         LA    R0,RTRYRTN1             RETRY ROUTINE - NO SDWA          00019133
         ST    R0,ESTAPARM             STORE IN PARAMETER LIST          00019233
         LA    R0,RTRYRTN2             RETRY ROUTINE - WITH SDWA        00019333
         ST    R0,ESTAPARM+4           STORE IN PARAMETER LIST          00019433
         STM   R11,R13,ESTAPARM+8      BASE/IEFYS WORK/DATA REGS        00019533
         ESTAE RECOVERY,CT,PARAM=ESTAPARM,MF=(E,ESTAEW) SETUP RCVRY     00019633
*                                                                       00019702
         CH    R3,=H'16'               IS THIS JOB TERMINATION?         00019809
         BE    GOBACK                    YES, RETURN TO SYSTEM          00019902
         CH    R3,=H'12'               IS THIS STEP TERMINATION?        00020009
         BNE   GOBACK                    NO, RETURN TO SYSTEM           00020102
*                                                                       00020211
         LA    R2,SYSOUTLN             GET ADDRESS OF SYSOUT BUFFER     00020310
         ST    R2,SYSOUT@              STORE ADDRESS FOR MOVES LATER    00020410
         LA    R2,132                  LENGTH OF SYSOUT BUFFER          00020534
         STH   R2,SYSOUT#              STORE LENGTH FOR MOVES LATER     00020610
*                                                                       00020712
         L     R10,PLSMFADR            GET ADDRESS OF SMF RECORD        00020812
         USING SMF4,R10                SET UP ADDRESSABILITY            00020912
*                                                                       00021014
* INITIALIZE CONSOLE MESSAGE LINE                                       00021114
*                                                                       00021214
         MVC   ACTRHDR,KWTOID          CONSTANT HEADER                  00021325
         MVI   ACTRSEP1,KSLASH         CONSTANT FIELD SEPARATOR         00021425
         MVI   ACTRSEP2,KSLASH         CONSTANT FIELD SEPARATOR         00021525
         MVI   ACTRSEP3,KSLASH         CONSTANT FIELD SEPARATOR         00021625
         MVI   ACTRSEP4,KSLASH         CONSTANT FIELD SEPARATOR         00021725
         MVI   ACTRSEP5,KSLASH         CONSTANT FIELD SEPARATOR         00021825
         MVC   ACTRJOBN(8),CEPJOBN     JOB NAME TO CONSOLE MESSAGE      00021937
*                                                                       00022013
* SYSOUT LINE #1 (INCLUDES JOB INFORMATION ON FIRST STEP)               00022113
*                                                                       00022213
         FILL  SYSOUTLN,KSTAR          INITIALIZE SYSOUT LINE 1         00022312
*                                                                       00022412
         CLI   CEPSNUM,X'01'           IS THIS FIRST STEP?              00022537
         BNE   NOJOBHD                   NO, SKIP JOB HEADING           00022602
*                                                                       00022702
* JOB NAME                                                              00022813
*                                                                       00022913
         MVC   SYSOUTLN+4(11),KSJOBNAM CONSTANT FIELD LABEL             00023034
         MVC   SYSOUTLN+15(8),CEPJOBN  JOB NAME                         00023137
*                                                                       00023213
* JOB CARD READ DATE/TIME (FROM SMF4 RECORD)                            00023325
*                                                                       00023413
         MVC   SYSOUTLN+23(14),KSJOBCRD CONSTANT FIELD LABEL            00023534
         MVC   DATEPACK(4),SMF4RSD     JOB CARD READ DATE               00023625
         BAL   R8,DATEFORM             CONFORM DATE TO Y2K AND EDIT     00023710
         MVC   SYSOUTLN+37(4),DATECHAR YEAR TO PRINT AREA               00023834
         MVI   SYSOUTLN+41,KSLASH        / TO PRINT AREA                00023934
         MVC   SYSOUTLN+42(3),DATECHAR+4   DAY TO PRINT AREA            00024034
         MVI   SYSOUTLN+45,KSPACE      SPACE AFTER DATE                 00024134
         ICM   R1,B'1111',SMF4RST      JOB CARD READ TIME               00024225
         LA    R2,KCLOCKM              MASK TO PRINT CLOCK TIME         00024325
         BAL   R8,TIMEFORM             CONVERT TIME TO PRINTABLE        00024403
         MVC   SYSOUTLN+46(8),TIMECHAR START TIME TO PRINT AREA         00024534
*                                                                       00024613
* CPU MODEL 370/???                                                     00024713
*                                                                       00024813
         MVC   SYSOUTLN+54(5),KSCPUMAJ COMPUTER MODEL MAJOR TO PRINT    00024934
         L     R5,16                   ADDRESS OF CVT                   00025003
         LA    R5,0(R5)                CLEAR HIGH ORDER BYTE            00025103
         S     R5,=F'8'                GET TO CVT PREFIX                00025203
         XC    DECW,DECW               CLEAR WORK FIELD                 00025303
         MVC   DECW+2(2),2(R5)         MOVE CPU MODEL NUMBER (EG. 0145) 00025403
         MVI   DECW+4,X'0C'            ADD SIGN (EG. 01450C)            00025503
         DP    DECW(5),=P'10'          DIVIDE BY 10 (EG. 00145C)        00025603
         MVC   CPUMODEL,=X'40202120'   EDIT MASK FOR CPU MODEL          00025711
         ED    CPUMODEL,DECW+1         EDIT CPU MODEL                   00025810
         MVC   SYSOUTLN+59(3),CPUMODEL+1 COMPUTER MODEL MINOR TO PRINT  00025934
*                                                                       00026013
* MVS RELEASE LEVEL (R03.8)                                             00026113
*                                                                       00026213
         MVC   SYSOUTLN+62(6),KSVS2    RELEASE NUMBER FIELD LABEL       00026334
         MVC   SYSOUTLN+68(2),4(R5)    MOVE RELEASE NUMBER TO PRINT     00026434
         MVI   SYSOUTLN+70,KPERIOD       DECIMAL POINT                  00026534
         MVC   SYSOUTLN+71(2),6(R5)        SUB RELEASE NUMBER TO PRINT  00026634
*                                                                       00026713
* SYSTEM IDENTIFIER (FROM SMF PARM)                                     00026813
*                                                                       00026913
         MVC   SYSOUTLN+73(4),CEPSYSID SYSTEM IDENTIFIER TO PRINT       00027037
         MVI   SYSOUTLN+77,KSPACE      SPACE AFTER SYSTEM ID            00027134
*                                                                       00027212
NOJOBHD  DS 0H                                                          00027312
         WRSYSOUT ,                    CALL IEFYS TO WRITE SYSOUT LINE  00027410
*                                                                       00027512
* SYSOUT LINE #2 (JUST A SEPARATOR LINE)                                00027613
*                                                                       00027713
         FILL  SYSOUTLN,KSPACE         INITIALIZE SYSOUT LINE 2         00027812
         MVI   SYSOUTLN,KSTAR            ..                             00027912
         MVI   SYSOUTLN+131,KSTAR          ..                           00028034
*                                                                       00028114
         WRSYSOUT ,                    CALL IEFYS TO WRITE SYSOUT LINE  00028212
*                                                                       00028304
* SYSOUT LINE #3                                                        00028413
*                                                                       00028513
         FILL  SYSOUTLN,KSPACE         INITIALIZE SYSOUT LINE 3         00028612
         MVI   SYSOUTLN,KSTAR            ..                             00028712
         MVI   SYSOUTLN+131,KSTAR          ..                           00028834
*                                                                       00028913
* STEP NUMBER (FROM SMF4 RECORD)                                        00029013
*                                                                       00029113
         MVC   SYSOUTLN+3(12),KSTEPNUM CONSTANT FIELD LABEL             00029234
         XR    R2,R2                   CLEAR R2                         00029312
         IC    R2,SMF4STN              INSERT STEP # FROM SMF4 RECORD   00029412
         CVD   R2,DECW                 CONVERT TO DECIMAL               00029512
         MVC   SYSOUTLN+22(4),=X'40202120' EDIT MASK FOR STEP NUMBER    00029634
         ED    SYSOUTLN+22(4),DECW+6   EDIT STEP NUMBER                 00029734
         MVC   ACTRSTPN,SMF4STMN       STEP NAME TO CONSOLE MSG         00029831
         CLI   SMF4STMN,KSPACE         WAS A STEP NAME SUPPLIED?        00029931
         BNE   STPNDONE                  YES, GO TO NEXT FIELD          00030031
         MVC   ACTRSTPN,KACTRSTP       CONSTANT (JS#999)                00030131
         MVC   ACTRSNNN(3),SYSOUTLN+23 STEP NUMBER TO CONSOLE MSG       00030234
*                                                                       00030331
STPNDONE DS    0H                                                       00030431
*                                                                       00030513
* USER CORE (FROM SMF4 RECORD)                                          00030613
*                                                                       00030713
         MVC   SYSOUTLN+28(10),KUSERCOR CONSTANT FIELD LABEL            00030834
         XR    R2,R2                   CLEAR R2                         00030912
         LH    R2,SMF4H0ST             GET PROBLEM PROGRAM CORE USED    00031012
         CVD   R2,DECW                 CONVERT TO DECIMAL               00031112
         MVC   SYSOUTLN+43(6),=X'402020202120' EDIT MASK FOR USER CORE  00031234
         ED    SYSOUTLN+43(6),DECW+5   EDIT USER CORE                   00031334
         MVI   SYSOUTLN+49,KK          CONSTANT 'K'                     00031434
*                                                                       00031513
* STEP START TIME HH:MM:SS.TT (FROM SMF4 RECORD)                        00031613
*                                                                       00031713
         MVC   SYSOUTLN+52(11),KSTRTTIM CONSTANT FIELD LABEL            00031834
         ICM   R1,B'1111',SMF4SIT      STEP INITIATION TIME             00031925
         LA    R2,KCLOCKM              MASK TO PRINT CLOCK TIME         00032025
         BAL   R8,TIMEFORM             CONVERT TIME TO PRINTABLE        00032112
         MVC   SYSOUTLN+66(11),TIMECHAR START TIME TO PRINT AREA        00032234
*                                                                       00032323
*        COPY FIELDS FROM SMF4 RELOCATE SECTION FOR USE LATER           00032423
*                                                                       00032523
         XR    R5,R5                   CLEAR R5                         00032623
         ICM   R5,B'0011',SMF4RLCT     GET OFFSET TO RELOCATE SECTION   00032730
         LA    R5,SMFRCD4+4(R5)        GET ADDR OF RELOCATE SECTION     00032823
         USING SMF4PGIN,R5             SET UP ADDRESSABILITY            00032923
         MVC   REL4PGIN(4),SMF4PGIN    NUMBER OF PAGE-INS               00033023
         MVC   REL4PGOT(4),SMF4PGOT    NUMBER OF PAGE-OUTS              00033123
         MVC   REL4NSW(4),SMF4NSW      NUMBER OF SWAPS                  00033223
         MVC   REL4PSI(4),SMF4PSI      PAGES SWAPPED IN                 00033323
         MVC   REL4PSO(4),SMF4PSO      PAGES SWAPPED OUT                00033423
         MVC   REL4VPI(4),SMF4VPI      VAM PAGE INS                     00033523
         MVC   REL4VPO(4),SMF4VPO      VAM PAGE OUTS                    00033623
         MVC   REL4SST(4),SMF4SST      STEP SERVICE TIME                00033723
         MVC   REL4ACT(4),SMF4ACT      STEP ACTIVE TIME                 00033823
         MVC   REL4PGNO(4),SMF4PGNO    PERFORMANCE GROUP NUMBER         00033934
         DROP  R5                      NO LONGER NEED ADDRESSABILITY    00034023
*                                                                       00034130
*        COPY FIELDS FROM SMF4 ACCOUNTING SECTION FOR USE LATER         00034230
*                                                                       00034330
         LA    R5,SMF4LENN             GET ADDRESS OF LENGTH OF THE    C00034430
                                         EXCP SECTION                   00034530
         AH    R5,SMF4LENN             GET ADDRESS OF CPU/ACCT SECTION  00034630
         XC    REL4SETM,REL4SETM       CLEAR FULLWORD                   00034730
         MVC   REL4SETM+1(3),1(R5)     STEP CPU TIME UNDER TCB (.01SEC) 00034838
*                                                                       00034913
* CPU TIME HH:MM:SS.TT (FROM PASSED PARAMETER LIST AND SMF4 RECORD)     00035015
*                                                                       00035113
         MVC   SYSOUTLN+79(9),KCPUTIM  CONSTANT FIELD LABEL             00035234
         L     R2,PLSETADR             GET ADDR OF STEP CPU TIME (TCB)  00035334
         XR    R1,R1                   CLEAR R1                         00035434
         ICM   R1,B'0111',0(R2)        GET TCB TIME                     00035540
         XR    R2,R2                   CLEAR R2                         00035623
         ICM   R2,B'0111',SMF4SRBT     GET STEP SRB TIME                00035723
         AR    R1,R2                   CPU+SRB = TCB TIME               00035823
         LA    R2,KPERIODM             MASK TO PRINT ELAPSED TIME       00035925
         BAL   R8,TIMEFORM             CONVERT TIME TO PRINTABLE        00036012
         MVC   SYSOUTLN+92(11),TIMECHAR STEP CPU TIME TO PRINT AREA     00036134
         MVC   ACTRCPUT(11),TIMECHAR   STEP CPU TIME TO CONSOLE MSG     00036214
*                                                                       00036334
* ACTIVE TIME  (FROM SMF4 RECORD)                                       00036434
*                                                                       00036534
         MVC   SYSOUTLN+105(12),KACTVTIM CONSTANT FIELD LABEL           00036634
         ICM   R7,B'1111',REL4ACT      GET STEP ACTIVE TIME            C00036734
                                         (UNIT IS 1024 MICROSECONDS)    00036834
         XR    R6,R6                   CLEAR R6 FOR MULTIPLY            00036934
         SLDL  R6,10                   MULTIPLY BY 1024 TO GET         C00037034
                                         TO GET MICROSECONDS            00037134
         AL    R7,=A(5000)             ROUND TO NEAREST HUNDREDTH      C00037234
                                         OF A SECOND                    00037334
         BC    12,BCSACTIM             BRANCH IF NO CARRY               00037434
         LA    R6,1(R6)                INCREMENT R6 ON OVERFLOW FROM R7 00037534
*                                                                       00037634
BCSACTIM D     R6,=A(10000)            REDUCE TO HUNDREDTHS OF SECONDS  00037734
         LR    R1,R7                   COPY R7 TO R1                    00037834
         LA    R2,KPERIODM             MASK TO PRINT ELAPSED TIME       00037934
         BAL   R8,TIMEFORM             CONVERT TIME TO PRINTABLE        00038034
         MVC   SYSOUTLN+119(11),TIMECHAR STEP ACTIVE TIME TO PRINT AREA 00038134
*                                                                       00038234
         WRSYSOUT ,                    CALL IEFYS TO WRITE SYSOUT LINE  00038334
*                                                                       00038413
* SYSOUT LINE #4                                                        00038513
*                                                                       00038613
         FILL  SYSOUTLN,KSPACE         INITIALIZE SYSOUT LINE 4         00038712
         MVI   SYSOUTLN,KSTAR            ..                             00038812
         MVI   SYSOUTLN+131,KSTAR          ..                           00038934
*                                                                       00039013
* STEP NAME (FROM SMF4 RECORD)                                          00039113
*                                                                       00039213
         MVC   SYSOUTLN+3(10),KSTEPNAM CONSTANT FIELD LABEL             00039334
         MVC   SYSOUTLN+18(8),SMF4STMN STEP NAME FROM SMF4 RECORD       00039434
*                                                                       00039513
* SYSTEM CORE USED ON USER'S BEHALF (FROM SMF4 RECORD)                  00039613
*                                                                       00039713
         MVC   SYSOUTLN+28(12),KSYSCOR CONSTANT FIELD LABEL             00039834
         LH    R1,SMF4SYST             SYS CORE USED ON USER'S BEHALF   00039912
         CVD   R1,DECW                 CONVERT TO DECIMAL               00040012
         MVC   SYSOUTLN+43(6),=X'402020202120' EDIT MASK FOR SYS CORE   00040134
         ED    SYSOUTLN+43(6),DECW+5   EDIT SYSTEM CORE                 00040234
         MVI   SYSOUTLN+49,KK          CONSTANT 'K'                     00040334
*                                                                       00040414
* STEP STOP TIME  (FROM SMF4 RECORD)                                    00040514
*                                                                       00040614
         MVC   SYSOUTLN+52(10),KSTOPTIM CONSTANT FIELD LABEL            00040734
         ICM   R1,B'1111',SMF4TME      STEP TERMINATION TIME            00040825
         LA    R2,KCLOCKM              MASK TO PRINT CLOCK TIME         00040925
         BAL   R8,TIMEFORM             CONVERT TIME TO PRINTABLE        00041014
         MVC   SYSOUTLN+66(11),TIMECHAR STOP TIME TO PRINT AREA         00041134
*                                                                       00041234
* SRB TIME HH:MM:SS.TT (FROM SMF4 RECORD)                               00041334
*                                                                       00041434
         MVC   SYSOUTLN+79(9),KSRBTIM  CONSTANT FIELD LABEL             00041534
         XR    R1,R1                   CLEAR R2                         00041644
         ICM   R1,B'0111',SMF4SRBT     GET STEP SRB TIME                00041744
         LA    R2,KPERIODM             MASK TO PRINT ELAPSED TIME       00041834
         BAL   R8,TIMEFORM             CONVERT TIME TO PRINTABLE        00041934
         MVC   SYSOUTLN+92(11),TIMECHAR STEP SRB TIME TO PRINT AREA     00042034
*                                                                       00042134
* ALLOCATION TIME (ALLOCATION START TIME, FROM SMF4 RECORD)             00042234
*                                                                       00042334
         MVC   SYSOUTLN+105(11),KALLOCTI CONSTANT FIELD LABEL           00042434
         XR    R1,R1                   CLEAR R1 FOR TIME                00042534
         ICM   R1,B'1111',SMF4AST      GET SMF4 ALLOCATION START TIME   00042634
         LA    R2,KCLOCKM              MASK TO PRINT CLOCK TIME         00042734
         BAL   R8,TIMEFORM             CONVERT TIME TO PRINTABLE        00042834
         MVC   SYSOUTLN+119(11),TIMECHAR START TIME TO PRINT AREA       00042934
*                                                                       00043034
         WRSYSOUT ,                    CALL IEFYS TO WRITE SYSOUT LINE  00043134
*                                                                       00043214
* SYSOUT LINE #5                                                        00043314
*                                                                       00043414
         FILL  SYSOUTLN,KSPACE         INITIALIZE SYSOUT LINE 5         00043514
         MVI   SYSOUTLN,KSTAR            ..                             00043614
         MVI   SYSOUTLN+131,KSTAR          ..                           00043734
*                                                                       00043814
* PROGRAM NAME (FROM SMF4 RECORD)                                       00043914
*                                                                       00044014
         MVC   SYSOUTLN+3(13),KPGMNAME CONSTANT FIELD LABEL             00044134
         MVC   SYSOUTLN+18(8),SMF4PGMN PROGRAM NAME FROM SMF4 RECORD    00044234
         MVC   ACTRPGMN(8),SMF4PGMN    PROGRAM NAME TO CONSOLE MSG      00044314
*                                                                       00044414
* REGION SIZE (FROM SMF4 RECORD)                                        00044514
*                                                                       00044614
         MVC   SYSOUTLN+28(12),KRGNSIZE CONSTANT FIELD LABEL            00044734
         LH    R2,SMF4RSH0              PRIVATE AREA SIZE               00044825
         CVD   R2,DECW                  CONVERT TO DECIMAL              00044925
         MVC   SYSOUTLN+43(6),=X'402020202120' EDIT MASK FOR REGION     00045034
         ED    SYSOUTLN+43(6),DECW+5    EDIT REGION SIZE                00045134
         MVI   SYSOUTLN+49,KK           CONSTANT 'K'                    00045234
         TM    SMF4RIN,B'00000001'      V=R JOBSTEP?                    00045321
         BZ    REGVRNO                    NO                            00045421
         MVC   SYSOUTLN+41(2),=C'VR'    INDICATE V=R                    00045534
*                                                                       00045625
REGVRNO  DS    0H                                                       00045721
*                                                                       00045813
* ELAPSED TIME HH:MM:SS.TT (FROM SMF4 RECORD)                           00045913
*                                                                       00046013
         MVC   SYSOUTLN+52(13),KELAPSED CONSTANT FIELD LABEL            00046134
         MVC   DECW+4(4),SMF4DTE       STEP END DATE                    00046222
         MVC   SMF4STID(1),SMF4DTE     COPY CENTURY BYTE TO START DATE  00046322
         SP    DECW+4(4),SMF4STID(4)   MINUS STEP START DATE            00046422
         XC    DECW(4),DECW            EQUALS NUMBER OF DAYS            00046522
         CVB   R1,DECW                 CONVERT TO BINARY                00046622
         XR    R0,R0                   CLEAR R0 FOR MULTIPLY            00046731
         M     R0,=A(24*60*60*100)     TIMES 100THS OF SECONDS PER DAY  00046822
         ICM   R3,B'1111',SMF4TME      GET STEP END TIME                00046922
         AR    R1,R3                   ADD TO DAYS ADJUST               00047022
         ICM   R3,B'1111',SMF4SIT      GET STEP START TIME              00047122
         SR    R1,R3                   SUBTRACT GIVING ELAPSED TIME     00047222
         LA    R2,KPERIODM             MASK TO PRINT ELAPSED TIME       00047325
         BAL   R8,TIMEFORM             CONVERT TIME TO PRINTABLE        00047412
         MVC   SYSOUTLN+66(11),TIMECHAR ELAPSED TIME TO PRINT AREA      00047534
         MVC   ACTRELAP(11),TIMECHAR   ELAPSED TIME TO CONSOLE MSG      00047614
*                                                                       00047713
* TCB TIME (FROM PARAMETER FIELD)                                       00047845
*                                                                       00047913
         MVC   SYSOUTLN+79(9),KTCBTIM  CONSTANT FIELD LABEL             00048034
         L     R2,PLSETADR             GET ADDR OF STEP CPU TIME (TCB)  00048138
         XR    R1,R1                   CLEAR R1                         00048238
         ICM   R1,B'0111',0(R2)        GET TCB TIME                     00048340
         LA    R2,KPERIODM             MASK TO PRINT ELAPSED TIME       00048438
         BAL   R8,TIMEFORM             CONVERT TIME TO PRINTABLE        00048538
         MVC   SYSOUTLN+92(11),TIMECHAR STEP TCB TIME TO PRINT AREA     00048634
*                                                                       00048734
* PROGRAM LOAD TIME  (FROM SMF4 RECORD)                                 00048834
*                                                                       00048934
         MVC   SYSOUTLN+105(13),KPGLDTIM CONSTANT FIELD LABEL           00049034
         ICM   R1,B'1111',SMF4PPST     GET PROBLEM PROGRAM START TIME   00049134
         LA    R2,KCLOCKM              MASK TO PRINT CLOCK TIME         00049234
         BAL   R8,TIMEFORM             CONVERT TIME TO PRINTABLE        00049334
         MVC   SYSOUTLN+119(11),TIMECHAR STEP SRB TIME TO PRINT AREA    00049434
*                                                                       00049514
         WRSYSOUT ,                    CALL IEFYS TO WRITE SYSOUT LINE  00049612
*                                                                       00049714
* SYSOUT LINE #6                                                        00049814
*                                                                       00049914
         FILL  SYSOUTLN,KSPACE         INITIALIZE SYSOUT LINE 6         00050014
         MVI   SYSOUTLN,KSTAR            ..                             00050114
         MVI   SYSOUTLN+131,KSTAR          ..                           00050234
*                                                                       00050314
* STEP COMPLETION CODE (FROM SMF4 RECORD)                               00050414
*                                                                       00050514
         TM    SMF4STI,B'00000001'     WAS STEP FLUSHED?                00050614
         BO    CCNOEXEC                  YES, GO HANDLE                 00050714
         MVC   SYSOUTLN+3(15),KCONDCDE CONSTANT FIELD LABEL             00050834
         TM    SMF4STI,B'00000010'     ABEND?                           00050914
         BO    CCABEND                   YES, GO HANDLE                 00051014
         XR    R1,R1                   CLEAR R1                         00051114
         ICM   R1,3,SMF4SCC            GET STEP CC                      00051214
         N     R1,=X'00000FFF'         CLEAR UNUSED PORTION             00051315
         CVD   R1,DECW                 CONVERT TO DECIMAL               00051414
         UNPK  UNPACKW(5),DECW+5(3)    UNPACK                           00051514
         OI    UNPACKW+4,X'F0'         CORRECT SIGN FOR PRINT           00051615
         MVC   SYSOUTLN+21(5),UNPACKW  MOVE TO PRINT                    00051734
         MVC   ACTRSCC(5),UNPACKW        AND CONSOLE MSG                00051816
         B     CCDONE                  CONTINUE WITH NEXT FIELD         00051914
*                                                                       00052014
CCNOEXEC DS    0H                                                       00052114
         MVC   SYSOUTLN+3(19),KFLUSHED INDICATE STEP NOT RUN            00052234
         MVC   ACTRSCC(5),=C'NOXEC'      AND ON CONSOLE MSG             00052314
         B     LN6DONE                 LINE COMPLETE, GO PRINT          00052414
*                                                                       00052514
CCABEND  DS    0H                                                       00052614
         TM    SMF4SCC,X'80'           USER ABEND?                      00052714
         BO    CCUSERAB                  YES, GO HANDLE                 00052814
         MVC   SYSOUTLN+21(2),=C'S-'   INDICATE SYSTEM ABEND CODE       00052934
         MVC   ACTRSCC(2),=C'S-'         AND ON CONSOLE MSG             00053014
         UNPK  DECW(4),SMF4SCC(3)      UNPACK                           00053114
         TR    DECW(4),HEXTRANS-X'F0'  TRANSLATE TO PRINTABLE           00053214
         MVC   SYSOUTLN+23(3),DECW     MOVE TO PRINT                    00053334
         MVC   ACTRSCC+2(3),DECW         AND CONSOLE MSG                00053414
         B     CCDONE                  CONTINUE WITH NEXT FIELD         00053514
*                                                                       00053614
CCUSERAB DS    0H                                                       00053714
         MVI   SYSOUTLN+21,C'U'        INDICATE USER ABEND CODE         00053834
         MVI   ACTRSCC,C'U'              AND ON CONSOLE MSG             00053914
         XR    R1,R1                   CLEAR R1                         00054014
         ICM   R1,3,SMF4SCC            GET STEP CC                      00054114
         N     R1,=X'00000FFF'         CLEAR UNUSED PORTION             00054215
         CVD   R1,DECW                 CONVERT TO DECIMAL               00054314
         UNPK  UNPACKW(5),DECW+5(3)    UNPACK                           00054414
         OI    UNPACKW+4,X'F0'         CORRECT SIGN FOR PRINT           00054515
         MVC   SYSOUTLN+22(4),UNPACKW+1 MOVE TO PRINT                   00054634
         MVC   ACTRSCC+1(4),UNPACKW+1   AND CONSOLE MSG                 00054715
*                                                                       00054814
CCDONE   DS    0H                                                       00054914
*                                                                       00055014
* PERFORMANCE GROUP NUMBER (FROM SMF4 RECORD)                           00055114
*                                                                       00055214
         MVC   SYSOUTLN+28(18),KPFMGRP CONSTANT FIELD LABEL             00055334
         XR    R1,R1                   CLEAR R1                         00055414
         ICM   R1,B'0011',REL4PGNO     GET PERFORMANCE GROUP NUMBER     00055531
         CVD   R1,DECW                 CONVERT TO DECIMAL               00055614
         UNPK  SYSOUTLN+47(3),DECW+6(2)                                 00055740
         OI    SYSOUTLN+49,X'F0'                                        00055840
*                                                                       00055914
LN6DONE  DS    0H                                                       00056014
         WRSYSOUT ,                    CALL IEFYS TO WRITE SYSOUT LINE  00056114
*                                                                       00056214
* SYSOUT LINE #7                                                        00056342
*                                                                       00056414
         FILL  SYSOUTLN,KSPACE         INITIALIZE SYSOUT LINE 7         00056514
         MVI   SYSOUTLN,KSTAR            ..                             00056614
         MVI   SYSOUTLN+131,KSTAR          ..                           00056734
         MVC   SYSOUTLN+57(38),KSUHEADL      ..                         00056842
         MVC   SYSOUTLN+95(35),KSUHEADR        ..                       00056942
*                                                                       00057042
* JES2 CARD IMAGES READ (FROM SMF4 RECORD)                              00057142
*                                                                       00057242
         MVC   SYSOUTLN+28(11),KJES2NCI CONSTANT FIELD LABEL            00057342
         XR    R1,R1                   CLEAR R1                         00057442
         ICM   R1,B'1111',SMF4NCI      GET JES2 CARD IMAGES READ        00057542
         CVD   R1,DECW                 CONVERT TO DECIMAL               00057642
         MVC   SYSOUTLN+39(11),=X'4020206B2020206B202120' EDIT MASK     00057742
         ED    SYSOUTLN+39(11),DECW+3  EDIT FOR PRINT                   00057842
*                                                                       00057914
         WRSYSOUT ,                    CALL IEFYS TO WRITE SYSOUT LINE  00058014
*                                                                       00058114
* SYSOUT LINE #8                                                        00058214
*                                                                       00058314
         FILL  SYSOUTLN,KSPACE         INITIALIZE SYSOUT LINE 8         00058414
         MVI   SYSOUTLN,KSTAR            ..                             00058514
         MVI   SYSOUTLN+131,KSTAR          ..                           00058634
*                                                                       00058714
* SERVICE UNITS (FROM SMF4 RECORD)                                      00058814
*                                                                       00058914
         ICM   R1,B'1111',REL4SST      GET # SERVICE UNITS USED BY STEP 00059025
         CVD   R1,DECW                 CONVERT TO DECIMAL               00059114
         MVC   SYSOUTLN+58(12),=X'402020206B2020206B202120' MASK        00059242
         ED    SYSOUTLN+58(12),DECW+3  EDIT TO PRINT                    00059342
*                                                                       00059414
* NUMBER OF PAGE-INS (FROM SMF4 RECORD)                                 00059514
*                                                                       00059614
         ICM   R1,B'1111',REL4PGIN     GET # OF PAGE-INS                00059725
         CVD   R1,DECW                 CONVERT TO DECIMAL               00059814
         MVC   SYSOUTLN+72(5),=X'4020202120' MASK                       00059942
         ED    SYSOUTLN+72(5),DECW+5   EDIT TO PRINT                    00060042
         MVI   SYSOUTLN+78,KSLASH      CONSTANT FIELD SEPARATOR         00060142
*                                                                       00060214
* NUMBER OF PAGE-OUTS (FROM SMF4 RECORD)                                00060314
*                                                                       00060414
         ICM   R1,B'1111',REL4PGOT     GET # OF PAGE-OUTS               00060525
         CVD   R1,DECW                 CONVERT TO DECIMAL               00060614
         MVC   SYSOUTLN+79(5),=X'4020202120' MASK                       00060742
         ED    SYSOUTLN+79(5),DECW+5   EDIT TO PRINT                    00060842
*                                                                       00060914
* NUMBER OF TIMES SWAPPED (FROM SMF4 RECORD)                            00061014
*                                                                       00061114
         ICM   R1,B'1111',REL4NSW      GET # TIMES SWAPPED              00061225
         CVD   R1,DECW                 CONVERT TO DECIMAL               00061314
         MVC   SYSOUTLN+88(5),=X'4020202120' MASK                       00061442
         ED    SYSOUTLN+88(5),DECW+5   EDIT TO PRINT                    00061542
*                                                                       00061614
* NUMBER OF PAGES SWAPPED IN (FROM SMF4 RECORD)                         00061714
*                                                                       00061814
         ICM   R1,B'1111',REL4PSI      GET # OF PAGES SWAPPED IN        00061925
         CVD   R1,DECW                 CONVERT TO DECIMAL               00062014
         MVC   SYSOUTLN+100(5),=X'4020202120' MASK                      00062142
         ED    SYSOUTLN+100(5),DECW+5   EDIT TO PRINT                   00062242
         MVI   SYSOUTLN+106,KSLASH      CONSTANT FIELD SEPARATOR        00062342
*                                                                       00062414
* NUMBER OF PAGES SWAPPED OUT (FROM SMF4 RECORD)                        00062514
*                                                                       00062614
         ICM   R1,B'1111',REL4PSO      GET # OF PAGES SWAPPED OUT       00062725
         CVD   R1,DECW                 CONVERT TO DECIMAL               00062814
         MVC   SYSOUTLN+107(5),=X'4020202120' MASK                      00062942
         ED    SYSOUTLN+107(5),DECW+5  EDIT TO PRINT                    00063042
*                                                                       00063114
* NUMBER OF VIO PAGES SWAPPED IN (FROM SMF4 RECORD)                     00063214
*                                                                       00063314
         ICM   R1,B'1111',REL4VPI      GET # VIO PAGES SWAPPED IN       00063425
         CVD   R1,DECW                 CONVERT TO DECIMAL               00063514
         MVC   SYSOUTLN+118(5),=X'4020202120' MASK                      00063642
         ED    SYSOUTLN+118(5),DECW+5  EDIT TO PRINT                    00063742
         MVI   SYSOUTLN+124,KSLASH     CONSTANT FIELD SEPARATOR         00063842
*                                                                       00063914
* NUMBER OF VIO PAGES SWAPPED OUT (FROM SMF4 RECORD)                    00064014
*                                                                       00064114
         ICM   R1,B'1111',REL4VPO      GET # VIO PAGES SWAPPED OUT      00064225
         CVD   R1,DECW                 CONVERT TO DECIMAL               00064314
         MVC   SYSOUTLN+125(5),=X'4020202120' MASK                      00064442
         ED    SYSOUTLN+125(5),DECW+5   EDIT TO PRINT                   00064542
*                                                                       00064614
         WRSYSOUT ,                    CALL IEFYS TO WRITE SYSOUT LINE  00064714
*                                                                       00064814
* SYSOUT LINE #9 (JUST A SEPARATOR LINE)                                00064914
*                                                                       00065014
         FILL  SYSOUTLN,KSPACE         INITIALIZE SYSOUT LINE 9         00065114
         MVI   SYSOUTLN,KSTAR            ..                             00065214
         MVI   SYSOUTLN+131,KSTAR          ..                           00065334
*                                                                       00065414
         WRSYSOUT ,                    CALL IEFYS TO WRITE SYSOUT LINE  00065514
*                                                                       00065604
* SYSOUT LINE #10 (HEADING FOR I/O COUNTS FOR DEVICES)                  00065739
*                                                                       00065804
         LH    R5,SMF4LENN             GET DEVICE ENTRY PORTION LENGTH  00065914
         SH    R5,=H'2'                MINUS 2 FOR LENGTH FIELD         00066014
         SRL   R5,3                    DIVIDED BY 8                     00066114
         LTR   R5,R5                   EQUALS NUMBER OF DEVICE ENTRIES  00066214
         BZ    CLOSEBOX                IF ZERO - SKIP WRITING SECTION   00066339
         LA    R6,SMF4LENN+2           ADDRESS OF FIRST DEVICE ENTRY    00066414
         FILL  SYSOUTLN,KSPACE         INITIALIZE SYSOUT LINE 10        00066539
         MVI   SYSOUTLN,KSTAR            ..                             00066639
         MVI   SYSOUTLN+131,KSTAR          ..                           00066739
         MVC   SYSOUTLN+4(19),KSEXCPHD       ..                         00066839
         MVC   SYSOUTLN+25(19),KSEXCPHD       ..                        00066939
         MVC   SYSOUTLN+46(19),KSEXCPHD         ..                      00067039
         MVC   SYSOUTLN+67(19),KSEXCPHD           ..                    00067139
         MVC   SYSOUTLN+88(19),KSEXCPHD             ..                  00067239
         MVC   SYSOUTLN+109(19),KSEXCPHD              ..                00067339
         XR    R3,R3                   CLEAR R3 (OFFSET ON LINE)        00067439
*                                                                       00067539
         WRSYSOUT ,                    CALL IEFYS TO WRITE SYSOUT LINE  00067639
*                                                                       00067739
* SYSOUT LINE #11-?? (EXCP I/O COUNTS FOR DEVICES)                      00067839
*                                                                       00067939
         FILL  SYSOUTLN,KSPACE         INITIALIZE SYSOUT LINE 10        00068039
         MVI   SYSOUTLN,KSTAR            ..                             00068139
         MVI   SYSOUTLN+131,KSTAR          ..                           00068239
*                                                                       00068334
*   LOOP THROUGH ALL SMF4 DEVICE ENTRIES                                00068434
*                                                                       00068534
NEXTDEVC DS    0H                                                       00068634
         MVC   EXCPBLOK,KEXCP          INITIALIZE OUTPUT FORMAT AREA    00068739
         MVC   DECW+5(2),2(R6)         GET UNIT ADDRESS                 00068839
         MVI   DECW+7,X'0C'            APPEND JUNK CHARACTER FO UNPK    00068939
         UNPK  UNPACKW(5),DECW+5(3)    UNPACK ADDRESS                   00069039
         TR    UNPACKW(4),HEXTRANS-C'0' TRANSLATE X'F1-FF' TO C'A-F'    00069139
         CLC   UNPACKW+1(3),=C'000'    IS ADDRESS ZERO?                 00069242
         BNE   ISITVIO                   NO, GO CHECK FOR VIO           00069346
         L     R0,4(R6)                GET EXCP COUNT FOR DEVICE        00069442
         LTR   R0,R0                   IS IT ZERO?                      00069542
         BE    EXCPNEXT                  YES, DON'T PRINT ANYTHING      00069642
         B     CONVEXCP                PRINT COUNT FOR DUMMY DEVICE     00069742
*                                                                       00069842
ISITVIO  DS    0H                                                       00069946
         MVC   EXCPADDR,UNPACKW+1      MOVE ADDRESS TO FORMAT AREA      00070046
         CLC   UNPACKW+1(3),=C'FFF'    DOES ADDRESS INDICATE VIO?       00070146
         BNE   DEVCNAME                  NO, GO DETERMINE DEVICE        00070246
         MVI   EXCPDEVC,C'D'           INDICATE CLASS IS DISK           00070346
         MVC   EXCPDEVN,=C' VIO'         AND NAME IS VIO                00070446
         B     CONVEXCP                AND REPORT COUNT                 00070546
*                                                                       00070646
DEVCNAME DS    0H                                                       00070742
         MVI   EXCPDEVC,C' '           DEFAULT DEVICE CLASS             00070839
         MVC   EXCPDEVN,=C'MISC'         AND NAME OF MISC               00070939
         CLI   0(R6),X'20'             IS IT A DASD DEVICE?             00071014
         BE    DASDDEVC                  YES, GO PROCESS                00071114
         CLI   0(R6),X'80'             IS IT A TAPE DEVICE?             00071214
         BNE   CONVEXCP                  NO, GO REPORT COUNT AS MISC    00071339
*                                                                       00071414
TAPEDEVC MVI   EXCPDEVC,C'T'           INDICATE TAPE DEVICE CLASS       00071539
         XR    R1,R1                   CLEAR R1                         00071639
         IC    R1,1(R6)                GET DEVICE TYPE                  00071714
         IC    R1,TAPEOFST(R1)         GET OFFSET TO TAPE DEVICE NAME   00071814
         LA    R1,TAPETABL(R1)         GET ADDRESS OF TAPE DEVICE NAME  00071914
         MVC   EXCPDEVN,0(R1)          MOVE DEVICE NAME TO FORMAT AREA  00072039
         B     CONVEXCP                                                 00072114
*                                                                       00072214
DASDDEVC MVI   EXCPDEVC,C'D'           INDICATE DASD DEVICE CLASS       00072339
         XR    R1,R1                   CLEAR R1                         00072439
         IC    R1,1(R6)                GET DEVICE TYPE                  00072514
         IC    R1,DASDOFST(R1)         GET OFFSET TO DASD DEVICE NAME   00072614
         LA    R1,DASDTABL(R1)         GET ADDRESS OF DEVICE NAME       00072714
         MVC   EXCPDEVN,0(R1)          MOVE DEVICE NAME TO FORMAT AREA  00072842
*                                                                       00072914
CONVEXCP L     R0,4(R6)                EXCP COUNT                       00073014
         CVD   R0,DECW                 CONVERT TO PACKED                00073114
         MVC   EXCPCNT,=X'40202020202020202120' SET UP EDIT MASK        00073226
         ED    EXCPCNT,DECW+3          EDIT TO FORMAT AREA              00073326
*                                                                       00073414
         XR    R0,R0                   CLEAR R0 FOR MULTIPLY            00073514
         LR    R1,R3                   GET THIS ENTRY NUMBER ON LINE    00073614
         M     R0,=F'21'               MULTIPLY BY LENGTH OF ENTRY      00073739
         LA    R2,SYSOUTLN+4           ADDRESS OF FIRST ENTRY           00073839
         AR    R2,R1                   OFFSET TO THIS ENTRY             00073914
         MVC   0(21,R2),EXCPBLOK       MOVE ENTRY TO SYSOUT BUFFER      00074039
         LA    R3,1(,R3)               INCREMENT ENTRY COUNT            00074114
         C     R3,=F'6'                IS THIS 6TH ENTRY ON LINE        00074239
         BL    EXCPNEXT                  NO, CONTINUE                   00074339
*                                                                       00074414
         WRSYSOUT ,                    CALL IEFYS TO WRITE SYSOUT LINE  00074514
         FILL  SYSOUTLN,KSPACE         RE-INITIALIZE SYSOUT LINE        00074614
         MVI   SYSOUTLN,KSTAR            ..                             00074714
         MVI   SYSOUTLN+131,KSTAR          ..                           00074834
         XR    R3,R3                   CLEAR R3 (OFFSET ON LINE)        00074914
*                                                                       00075014
EXCPNEXT DS    0H                                                       00075139
         LA    R6,8(R6)                BUMP TO NEXT SMF4 DEVICE ENTRY   00075239
         BCT   R5,NEXTDEVC             GO AGAIN IF MORE DEVICES         00075339
*                                                                       00075414
         LTR   R3,R3                   ARE THERE ENTRIES IN BUFFER?     00075514
         BZ    EXCPERRS                  NO, GO CHECK FOR EXCEPTION     00075614
         WRSYSOUT ,                    CALL IEFYS TO WRITE SYSOUT LINE  00075714
*                                                                       00075814
EXCPERRS DS    0H                                                       00075914
         TM    SMF4RIN,X'02'           WERE THER EXCP COUNT ERRORS?     00076039
         BZ    CLOSEBOX                  NO - SKIP WARNING LINE         00076139
         FILL  SYSOUTLN,KSPACE         RE-INITIALIZE SYSOUT LINE        00076234
         MVI   SYSOUTLN,KSTAR            ..                             00076334
         MVI   SYSOUTLN+131,KSTAR          ..                           00076434
         MVC   SYSOUTLN+30(42),KWARN   WARNING MESSAGE TO SYSOUT LINE   00076539
         WRSYSOUT ,                    CALL IEFYS TO WRITE SYSOUT LINE  00076639
*                                                                       00076714
CLOSEBOX DS    0H                                                       00076814
*                                                                       00076914
* FINAL SYSOUT LINE (ALL ASTERISKS)                                     00077014
*                                                                       00077114
         FILL  SYSOUTLN,KSTAR          INITIALIZE FINAL SYSOUT LINE     00077214
*                                                                       00077314
         WRSYSOUT ,                    CALL IEFYS TO WRITE SYSOUT LINE  00077414
*                                                                       00077534
* WRITE IEFACTRT MESSAGE TO CONSOLE                                     00077645
*                                                                       00077714
         STEPWTO  ,                    WRITE MESSAGE TO CONSOLE         00077814
*                                                                       00077904
*********************************************************************** 00078001
* EXIT BACK TO SYSTEM                                                 * 00078101
*********************************************************************** 00078201
GOBACK   DS    0H                                                       00078302
         ESTAE 0                       CANCEL ESTAE EXIT                00078433
RTRYRTN2 DS    0H                      ESTAE RETRY ROUTINE WITH SDWA    00078533
*                                        JUST FREE STORAGE AND EXIT     00078633
         L     R3,4(R13)               RETRIEVE SYSTEM SAVE AREA ADDR   00078712
         L     R0,WALNGTH              LOAD FREEMAIN INFORMATION        00078845
         LR    R1,R13                  LOAD ADDRESS OF WORKAREA MEMORY  00078915
         FREEMAIN R,LV=(0),A=(1)       FREE ACQUIRED MEMORY             00079034
         LR    R13,R3                  RESTORE CALLER'S SAVE AREA       00079115
QUIKEXIT DS    0H                                                       00079243
         LM    R14,R12,12(R13)         RESTORE CALLER'S REGISTERS       00079315
         BR    R14                     RETURN TO SYSTEM                 00079402
*********************************************************************** 00079533
*                                                                     * 00079633
*  ESTAE EXIT ROUTINE                                                 * 00079733
*                                                                     * 00079833
*********************************************************************** 00079933
RECOVERY DS    0H                                                       00080033
         USING *,R15                   SET UP ADDRESSABILITY            00080133
         LA    R4,4                    PUT 4 IN REGISTER FOR COMPARE    00080233
         CR    R0,R4                   IS SDWA PRESENT?                 00080333
         BNE   HAVESDWA                YES, BR TO PROCESS WITH SDWA     00080433
         L     R0,0(R2)                LOAD RETRY ADDR FROM PARM LIST   00080533
         LA    R15,4                   SET RETCODE TO RETRY ADDR IN R0  00080633
         BR    R14                     RETURN WITH RETRY ADDR           00080733
HAVESDWA DS    0H                      ENTER HERE IF SDWA PRESENT       00080833
         ST    R14,12(R13)             SAVE RETURN ADDRESS              00080933
         L     R2,0(R1)                LOAD PARM LIST ADDR FROM SDWA    00081033
         L     R2,4(R2)                LOAD RETRY ADDRESS               00081133
         SETRP RC=4,,RETADDR=(2),RETREGS=YES,FRESDWA=YES,REGS=(14)      00081233
         DROP  R15                                                      00081333
*********************************************************************** 00081433
*                                                                     * 00081533
*  ESTAE RETRY ROUTINE WHEN NO SDWA WAS PRESENT                       * 00081633
*                                                                     * 00081733
*********************************************************************** 00081833
RTRYRTN1 DS    0H                      ROUTINE WITH NO SDWA PRESENT     00081933
         LM    R11,R13,8(R1)           LOAD REGS FOR ESTAE PARM LIST    00082033
         B     RTRYRTN2                  AND GET OUT                    00082133
*********************************************************************** 00082202
* CONVERT JULIAN DATE IN 4 CHARACTER PACKED FIELD (0YYDDDS) PLACED IN * 00082303
* DATEPACK TO VALID Y2K FORMAT (YYYYDDDS); UNPACKED VERSION WILL BE   * 00082425
* AVAILABLE IN DATECHAR.                                              * 00082525
*********************************************************************** 00082602
DATEFORM DS    0H                                                       00082704
         UNPK  DATECHAR(7),DATEPACK    UNPACK 4 BYTE JULIAN DATE        00082803
         OI    DATECHAR+6,X'F0'        CORRECT SIGN FIELD               00082903
         CLC   DATECHAR(2),=C'00'      SMF DATE (00YYDDD)?              00083003
         BNE   DATEFO01                  BRANCH IF NOT                  00083103
         MVC   DATECHAR(2),=C'19'      CHANGE YEAR TO 1900              00083203
DATEFO01 CLC   DATECHAR(2),=C'01'      SMF DATE (01YYDDD)?              00083303
         BNE   DATEFO02                  BRANCH IF NOT                  00083403
         MVC   DATECHAR(2),=C'20'      CHANGE YEAR TO 2000              00083503
DATEFO02 PACK  DATEPACK,DATECHAR(7)    REPACK MODIFIED DATE             00083604
         BR    R8                      RETURN                           00083703
         EJECT                                                          00083803
*********************************************************************** 00083903
* CONVERT TIME IN 100THS OF SECONDS (IN R1) TO A PRINTABLE            * 00084031
* FIELD IN THE FORMAT: HH.MM.SS.HH (WILL BE IN TIMECHAR)              * 00084125
*********************************************************************** 00084203
TIMEFORM DS    0H                                                       00084303
         XR    R0,R0                   CLEAR R0 FOR DIVISION            00084431
         D     R0,=A(60*60*100)        COMPUTE HOURS IN R1              00084503
         LR    R7,R1                   SAVE MINUTES                     00084603
         SRDL  R0,32                   REMAINDER TO R1 (CLEAR R0)       00084703
         D     R0,=A(60*100)           COMPUTE MINUTES IN R1            00084803
         M     R6,=F'100'              SHIFT LEFT TWO DIGITS            00084903
         AR    R7,R1                   ADD MINUTES TO HOURS             00085003
         SRDL  R0,32                   REMAINDER TO R1 (CLEAR R0)       00085103
         D     R0,=A(100)              COMPUTE SECONDS IN R1            00085203
*                                      AND 100THS OF SECONDS IN R0      00085303
         M     R6,=F'100'              SHIFT LEFT TWO DIGITS            00085403
         AR    R7,R1                   ADD SECONDS TO MINUTES AND HOURS 00085503
         M     R6,=F'100'              SHIFT LEFT TWO DIGITS            00085603
         AR    R7,R0                   ADD 100THS OF SECONDS            00085703
         CVD   R7,DECW                 CONVERT TO DECIMAL               00085803
         MVC   TIMECHAR-2(13),0(R2)    MOVE MASK TO PRINT AREA          00085925
         ED    TIMECHAR-2(13),DECW+3   EDIT                             00086025
         BR    R8                      AND RETURN                       00086103
         EJECT                                                          00086202
*********************************************************************** 00086302
* CONSTANTS                                                           * 00086402
*********************************************************************** 00086502
KSPACE   EQU   X'40'                   SPACE                            00086612
KSTAR    EQU   C'*'                    ASTERISK                         00086712
KCOMMA   EQU   C','                    COMMA                            00086812
KPERIOD  EQU   C'.'                    PERIOD                           00086912
KRPAREN  EQU   C')'                    RIGHT PARENTHESIS                00087012
KLPAREN  EQU   C'('                    LEFT PARENTHESIS                 00087112
KSLASH   EQU   C'/'                    SLASH                            00087212
KCOLON   EQU   C':'                    COLON                            00087312
KK       EQU   C'K'                    K                                00087412
KCLOCKM  DC    XL13'402120207A20207A2020404040'                         00087525
KPERIODM DC    XL13'402120207A20207A20204B2020'                         00087625
KWTOID   DC    CL9'IEFACTRT '                                           00087726
KSJOBNAM DC    CL11' JOB NAME: '                                        00087810
KSJOBCRD DC    CL14' JOBCARD READ '                                     00087911
KSCPUMAJ DC    CL5' 370/'                                               00088010
KSVS2    DC    CL6' VS2 R'                                              00088110
KSTEPNUM DC    CL12'STEP NUMBER:'                                       00088212
KACTRSTP DC    CL8'(JS#000)'                                            00088314
KUSERCOR DC    CL10'USER CORE:'                                         00088412
KSTEPNAM DC    CL10'STEP NAME:'                                         00088512
KSTRTTIM DC    CL11'START TIME:'                                        00088612
KCPUTIM  DC    CL9'CPU TIME:'                                           00088712
KSRBTIM  DC    CL9'SRB TIME:'                                           00088812
KSYSCOR  DC    CL12'SYSTEM CORE:'                                       00088912
KSTOPTIM DC    CL10'STOP TIME:'                                         00089014
KACTVTIM DC    CL12'ACTIVE TIME:'                                       00089114
KPGLDTIM DC    CL13'PROGRAM LOAD:'                                      00089214
KELAPSED DC    CL13'ELAPSED TIME:'                                      00089312
KTCBTIM  DC    CL9'TCB TIME:'                                           00089412
KALLOCTI DC    CL11'ALLOC TIME:'                                        00089513
KPGMNAME DC    CL13'PROGRAM NAME:'                                      00089639
KRGNSIZE DC    CL12'REGION SIZE:'                                       00089714
KCONDCDE DC    CL15'CONDITION CODE:'                                    00089814
KFLUSHED DC    CL19'-STEP NOT EXECUTED-'                                00089914
KPFMGRP  DC    CL18'PERFORMANCE GROUP:'                                 00090013
KJES2NCI DC    CL11'JES2 CARDS:'                                        00090142
KSUHEADL DC    CL38'SERVICE UNITS  PAGES IN/OUT  # SWAPS  '             00090214
KSUHEADR DC    CL35'PAGES SWAP IN/OUT  VIO PAGES IN/OUT'                00090314
KSEXCPHD DC    CL19'ADDR/UNIT I/O COUNT'                                00090439
KEXCP    DC    CL21'JES/DUMMY 999999999  '                              00090539
KWARN    DC    CL42'*** WARNING: EXCP COUNTS MAY BE WRONG ***'          00090639
WALNGTH  DC    0F'0',AL1(SUBPOOL),AL3(WORKAEND-WORKAREA)                00090726
WTODEF   WTO   '.........1.........2.........3.........4.........5.....C00090802
               ....6.....',ROUTCDE=2,DESC=(6),MF=L                      00090926
WTODEFL  EQU   *-WTODEF                LENGTH OF MODEL WTO              00091033
WTOMSGL  EQU   (WTODEFL-8)             LENGTH OF WTO MESSAGE AREA   JLM 00091148
ESTAEL   ESTAE MF=L                    MODEL ESTAE PARM LIST            00091233
LESTAEL  EQU   *-ESTAEL                LENGTH OF MODEL ESTAE            00091345
HEXTRANS DC    C'0123456789ABCDEF'                                      00091414
*********************************************************************** 00091514
*                                                                     * 00091614
*   DASD DEVICE NAME OFFSETS AND TABLE                                * 00091714
*                                                                     * 00091814
*********************************************************************** 00091914
DASDOFST DC    AL1(DADASD-DASDTABL)    00    GENERIC 'DASD'             00092045
         DC    AL1(DA2311-DASDTABL)    01    '2311'                     00092145
         DC    AL1(DADASD-DASDTABL)    02    GENERIC 'DASD'             00092245
         DC    AL1(DADASD-DASDTABL)    03    GENERIC 'DASD'             00092345
         DC    AL1(DADASD-DASDTABL)    04    GENERIC 'DASD'             00092445
         DC    AL1(DADASD-DASDTABL)    05    GENERIC 'DASD'             00092545
         DC    AL1(DADASD-DASDTABL)    06    GENERIC 'DASD'             00092645
         DC    AL1(DADASD-DASDTABL)    07    GENERIC 'DASD'             00092745
         DC    AL1(DA2314-DASDTABL)    08    '2314'                     00092845
         DC    AL1(DA3330-DASDTABL)    09    '3330'                     00092945
         DC    AL1(DA3340-DASDTABL)    0A    '3340'                     00093045
         DC    AL1(DA3350-DASDTABL)    0B    '3350'                     00093145
         DC    AL1(DA3375-DASDTABL)    0C    '3375'                     00093245
         DC    AL1(DA3330-DASDTABL)    0D    '3330'                     00093345
         DC    AL1(DA3380-DASDTABL)    0E    '3380'                     00093445
         DC    AL1(DA3390-DASDTABL)    0F    '3390'                     00093545
DASDTABL DS    0D                                                       00093614
DADASD   DC    CL4'DASD'                                                00093714
DA2311   DC    CL6'2311'                                                00093814
DA2314   DC    CL6'2314'                                                00093914
DA3330   DC    CL6'3330'                                                00094014
DA3340   DC    CL6'3340'                                                00094114
DA3350   DC    CL6'3350'                                        *JLM*   00094214
DA3375   DC    CL6'3375'                                        *JLM*   00094314
DA3380   DC    CL6'3380'                                        *JLM*   00094414
DA3390   DC    CL6'3390'                                        *JLM*   00094514
*********************************************************************** 00094614
*                                                                     * 00094714
*   TAPE DEVICE NAME OFFSETS AND TABLE                                * 00094814
*                                                                     * 00094914
*********************************************************************** 00095014
TAPEOFST DC    AL1(TATAPE-TAPETABL)    00    GENERIC 'TAPE'             00095145
         DC    AL1(TA2400-TAPETABL)    01    '2400'                     00095245
         DC    AL1(TATAPE-TAPETABL)    02    GENERIC 'TAPE'             00095345
         DC    AL1(TA3400-TAPETABL)    03    '3400'                     00095445
TAPETABL DS    0D                                                       00095514
TATAPE   DC    CL6'TAPE'                                                00095614
TA2400   DC    CL6'2400'                                                00095714
TA3400   DC    CL6'3400'                                                00095814
         EJECT                                                          00095900
*********************************************************************** 00096000
* WORK AREA ALLOCATED VIA GETMAIN                                     * 00096101
*********************************************************************** 00096200
WORKAREA DSECT                                                          00096300
         DS    18F                     STANDARD REGISTER SAVE AREA      00096406
ESTAEW   DS    XL(LESTAEL)             ESTAE PARM LIST AREA             00096533
ESTAPARM DS    5F                      PARM LIST PASSED TO RETRY RTN    00096633
*                                        RETRY ROUTINE ADDRESS (NO SWDA 00096734
*                                        RETRY ROUTINE ADDRESS (SWDA    00096834
*                                        BASE REGISTER R11              00096933
*                                        IEFYS PARMS   R12              00097033
*                                        DATA REGISTER R13              00097133
* * * * * * * *  PARAMETERS PASSED ON ENTRY SAVED BELOW * * * * * * * * 00097237
PLCEPADR DS    F                       ADDR OF COMMON EXIT PARM AREA    00097335
PLSTPADR DS    F                       ADDR OF STEPNAME                 00097435
PLPGNADR DS    F                       ADDR OF PROGRAMMER'S NAME        00097535
PLJETADR DS    F                       ADDR OF JOB EXECUTION TIME       00097635
PLJAFADR DS    F                       ADDR OF JOB ACCOUNTING INFO      00097735
PLSETADR DS    F                       ADDR OF STEP EXECUTION TIME      00097835
PLSAFADR DS    F                       ADDR OF STEP ACCOUNTING INFO     00097935
PLFSNADR DS    F                       ADDR OF FLAG AND STEP NUM        00098035
PLTSTADR DS    F                       ADDR OF TERMINATION STATUS       00098135
PLSMFADR DS    F                       ADDR OF TERMINATION RECORD       00098235
* * * * * * * *  PARAMETERS PASSED ON ENTRY SAVED ABOVE * * * * * * * * 00098337
* * * *  * * COMMON EXIT PARAMETER LIST FIELDS SAVED BELOW  * * * * * * 00098437
CEPJOBN  DS    CL8                      JOBNAME                         00098537
CEPTIME  DS    CL8                      TIME STAMP                      00098637
CEPSYSID DS    CL4                      SMF SYSTEM ID                   00098737
CEPUID   DS    CL8                      USER ID                         00098837
CEPSNUM  DS    CL1                      STEP NUMBER                     00098937
CEPSMFOP DS    CL1                      SMF OPTION                      00099037
CEPRSTID DS    CL1                      RESTART INDICATOR               00099137
CEPJCLAS DS    CL1                      JOB CLASS                       00099237
CEPUCOMM DS    0F                       USER COMMUNICATION AREA         00099337
CEPUCOMH DS    C                        USER COMMUNICATION AREA HEADER  00099437
CEPUCOMT DS    CL3                      USER COMMUNICATION AREA TRAILER 00099537
* * * *  * * COMMON EXIT PARAMETER LIST FIELDS SAVED ABOVE  * * * * * * 00099637
         DS    0F                                                       00099726
WTOBUF   DS    CL(WTODEFL)             WTO BUFFER                       00099826
ACTRMSG  DS    0CL(WTOMSGL)            CONSOLE MESSAGE                  00099925
ACTRHDR  DS    CL9                       MESSAGE HEADER 'IEFACTRT '     00100026
ACTRSTPN DS    CL8                       STEP NUMBER    '(JS#999)'      00100114
ACTRSNNN EQU   ACTRSTPN+4,3                                  999        00100245
ACTRSEP1 DS    CL1                       SEPARATOR      '/'             00100314
ACTRPGMN DS    CL8                       PROGRAM NAME                   00100414
ACTRSEP2 DS    CL1                       SEPARATOR      '/'             00100514
ACTRCPUT DS    CL11                      CPU TIME                       00100614
ACTRSEP3 DS    CL1                       SEPARATOR      '/'             00100714
ACTRELAP DS    CL11                      CLOCK TIME                     00100814
ACTRSEP4 DS    CL1                       SEPARATOR      '/'             00100914
ACTRSCC  DS    CL5                       STEP COMPLETION CODE           00101014
ACTRSEP5 DS    CL1                       SEPARATOR      '/'             00101114
ACTRJOBN DS    CL8                       JOB NAME                       00101214
SYSOUT@  DS    F                       ADDRESS OF SYSOUT LINE           00101310
SYSOUT#  DS    H                       LENGTH OF SYSOUT LINE            00101434
SYSOUTLN DS    CL132                   AREA TO BUILD SYSOUT LINE        00101534
DATEPACK DS    PL4                     DATE FOR CORRECTION/CONVERSION   00101603
DATECHAR DS    CL8                     JULIAN DATE YYYYDDD              00101703
DECW     DS    D                       DECIMAL CONVERSION WORK FIELD    00101803
PACKW    DS    PL4                     PACKED WORK AREA                 00101912
UNPACKW  DS    CL8                     UNPACKED WORK AREA               00102014
CPUMODEL DS    CL4                     EDIT FIELD FOR CPU MODEL         00102145
         DS    CL2                     TIME CONVERSION REQUIRED FILLER  00102203
TIMECHAR DS    CL11                    TIME CONVERSION FIELD            00102303
*        FIELDS BELOW COPIED FROM SMF4 RELOCATE SECTION                 00102414
REL4PGIN DS    BL4                     NUMBER OF PAGE-INS               00102534
REL4PGOT DS    BL4                     NUMBER OF PAGE-OUTS              00102634
REL4NSW  DS    BL4                     NUMBER OF SWAPS                  00102734
REL4PSI  DS    BL4                     PAGES SWAPPED IN                 00102834
REL4PSO  DS    BL4                     PAGES SWAPPED OUT                00102934
REL4VPI  DS    BL4                     VAM PAGE INS                     00103034
REL4VPO  DS    BL4                     VAM PAGE OUTS                    00103134
*        FIELDS BELOW COPIED FROM SMF4 PERFORMANCE SECTION              00103214
REL4SST  DS    BL4                     STEP SERVICE TIME                00103334
REL4ACT  DS    BL4                     STEP ACTIVE TIME                 00103434
REL4PGNO DS    BL2                     PERFORMANCE NUMBER               00103534
*        FIELDS BELOW COPIED FROM SMF4 ACCOUNTING SECTION               00103630
         DS 0H                                                          00103731
REL4SETM DS    BL4                     STEP CPU TIME UNDER TCB (.01SEC) 00103834
*        FIELDS ABOVE COPIED FROM SMF4 RELOCATABLE SECTIONS             00103930
EXCPBLOK DS    0CL21                   OUTPUT BUILD AREA FOR EXCP ENTRY 00104039
         DS    CL3                       CUU ADDRESS                    00104114
EXCPADDR EQU   EXCPBLOK,3                 " "                           00104245
         DS    CL1                       /                              00104314
         DS    CL5                       DEVICE CLASS/NAME              00104439
EXCPDEVC EQU   EXCPBLOK+4,1               " "                           00104545
EXCPDEVN EQU   EXCPBLOK+5,4               " "                           00104645
         DS    CL10                      I/O COUNT                      00104739
EXCPCNT  EQU   EXCPBLOK+9,10              " "                           00104845
         DS    CL2                                                      00104939
WORKAEND DS    0F                      END OF GETMAIN WORK AREA         00105045
*                                                                       00105139
*********************************************************************** 00105239
* SYSTEM RECORD DSECTS                                                * 00105343
*********************************************************************** 00105439
         PUSH PRINT                                                     00105539
         PRINT NOGEN                                                    00105639
SMF4     DSECT                                                          00105739
         IFASMFR 4                      SMF 4 RECORD                    00105833
         IHASDWA DSECT=YES              SDWA FOR ESTAE/SETRP MACRO      00105933
         IEFJMR                         JOB MGMT                        00106043
         POP PRINT                                                      00106112
         END   IEFACTRT                                                 00106202

./ ENDUP
/*
//*
//SMPASM02 EXEC SMPASM,M=IEFACTRT,COND=(0,NE)
//*
//RECV03   EXEC SMPAPP,COND=(0,NE),WORK=SYSALLDA
//SMPPTFIN DD  *
++USERMOD (JLM0001)
  .
++VER (Z038)
  FMID(EBB1102)
  .
++MOD(IEFACTRT)
  TXLIB(UMODOBJ)
  .
/*
//SMPCNTL  DD  *
 REJECT
         SELECT(JLM0001)
         .
 RESETRC .
 RECEIVE
         SELECT(JLM0001)
         .
  APPLY
        SELECT(JLM0001)
        DIS(WRITE)
        .
//
